IB/core: Make testing MR flags for writability a static inline function
[linux-2.6-block.git] / scripts / kconfig / Makefile
CommitLineData
b2441318 1# SPDX-License-Identifier: GPL-2.0
1da177e4
LT
2# ===========================================================================
3# Kernel configuration targets
4# These targets are used from top-level makefile
5
911a91c3 6PHONY += xconfig gconfig menuconfig config syncconfig update-po-config \
281c9dad 7 localmodconfig localyesconfig
1da177e4 8
61bee204
AV
9ifdef KBUILD_KCONFIG
10Kconfig := $(KBUILD_KCONFIG)
11else
838a2e55 12Kconfig := Kconfig
61bee204 13endif
e703f75d 14
0a1f00a1
MM
15ifeq ($(quiet),silent_)
16silent := -s
17endif
18
c2838e6e
YM
19# We need this, in case the user has it in its environment
20unexport CONFIG_
21
1da177e4 22xconfig: $(obj)/qconf
0a1f00a1 23 $< $(silent) $(Kconfig)
1da177e4
LT
24
25gconfig: $(obj)/gconf
0a1f00a1 26 $< $(silent) $(Kconfig)
1da177e4
LT
27
28menuconfig: $(obj)/mconf
0a1f00a1 29 $< $(silent) $(Kconfig)
1da177e4
LT
30
31config: $(obj)/conf
0a1f00a1 32 $< $(silent) --oldaskconfig $(Kconfig)
1da177e4 33
692d97c3 34nconfig: $(obj)/nconf
0a1f00a1 35 $< $(silent) $(Kconfig)
692d97c3 36
cedd55d4
MH
37# This has become an internal implementation detail and is now deprecated
38# for external use.
911a91c3 39syncconfig: $(obj)/conf
9815594a 40 $(Q)mkdir -p include/config include/generated
0a1f00a1 41 $< $(silent) --$@ $(Kconfig)
1da177e4 42
2a616258 43localyesconfig localmodconfig: $(obj)/conf
9815594a 44 $(Q)mkdir -p include/config include/generated
2a616258 45 $(Q)perl $(srctree)/$(src)/streamline_config.pl --$@ $(srctree) $(Kconfig) > .tmp.config
7a996d3a 46 $(Q)if [ -f .config ]; then \
4062f1a4
SR
47 cmp -s .tmp.config .config || \
48 (mv -f .config .config.old.1; \
49 mv -f .tmp.config .config; \
2a616258 50 $< $(silent) --oldconfig $(Kconfig); \
4062f1a4
SR
51 mv -f .config.old.1 .config.old) \
52 else \
53 mv -f .tmp.config .config; \
2a616258 54 $< $(silent) --oldconfig $(Kconfig); \
a7c02602 55 fi
03fa25da
SR
56 $(Q)rm -f .tmp.config
57
1020026f 58# Create new linux.pot file
b70e325c 59# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
46d26319 60update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
0a1f00a1 61 $(Q)$(kecho) " GEN config.pot"
a24a1b8e
PF
62 $(Q)xgettext --default-domain=linux \
63 --add-comments --keyword=_ --keyword=N_ \
64 --from-code=UTF-8 \
65 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
66 --directory=$(srctree) --directory=$(objtree) \
b70e325c
SR
67 --output $(obj)/config.pot
68 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
fa0ad657
PB
69 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
70 $(srctree)/arch/*/um/Kconfig`; \
1020026f 71 do \
0a1f00a1 72 $(kecho) " GEN $$i"; \
4217516e 73 $(obj)/kxgettext $$i \
1020026f
EG
74 >> $(obj)/config.pot; \
75 done )
0a1f00a1 76 $(Q)$(kecho) " GEN linux.pot"
1020026f 77 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
b70e325c 78 --output $(obj)/linux.pot
b70e325c 79 $(Q)rm -f $(obj)/config.pot
3b9fa093 80
1cba0c30
MM
81# These targets map 1:1 to the commandline options of 'conf'
82simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
83 alldefconfig randconfig listnewconfig olddefconfig
84PHONY += $(simple-targets)
1da177e4 85
1cba0c30 86$(simple-targets): $(obj)/conf
0a1f00a1 87 $< $(silent) --$@ $(Kconfig)
1da177e4 88
911a91c3 89PHONY += oldnoconfig silentoldconfig savedefconfig defconfig
1da177e4 90
fb16d891 91# oldnoconfig is an alias of olddefconfig, because people already are dependent
39c3f1ba 92# on its behavior (sets new symbols to their default value but not 'n') with the
fb16d891 93# counter-intuitive name.
1cba0c30 94oldnoconfig: olddefconfig
312ee687
MY
95 @echo " WARNING: \"oldnoconfig\" target will be removed after Linux 4.19"
96 @echo " Please use \"olddefconfig\" instead, which is an alias."
fb16d891 97
911a91c3
MY
98# We do not expect manual invokcation of "silentoldcofig" (or "syncconfig").
99silentoldconfig: syncconfig
100 @echo " WARNING: \"silentoldconfig\" has been renamed to \"syncconfig\""
101 @echo " and is now an internal implementation detail."
102 @echo " What you want is probably \"oldconfig\"."
103 @echo " \"silentoldconfig\" will be removed after Linux 4.19"
104
7cf3d73b 105savedefconfig: $(obj)/conf
0a1f00a1 106 $< $(silent) --$@=defconfig $(Kconfig)
7cf3d73b 107
1da177e4
LT
108defconfig: $(obj)/conf
109ifeq ($(KBUILD_DEFCONFIG),)
0a1f00a1 110 $< $(silent) --defconfig $(Kconfig)
42f9d3c6
JB
111else
112ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
0a1f00a1
MM
113 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
114 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
d2036f30
ME
115else
116 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
117 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
1da177e4 118endif
42f9d3c6 119endif
1da177e4
LT
120
121%_defconfig: $(obj)/conf
0a1f00a1 122 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
1da177e4 123
63a91033 124configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
3aaefce1 125
63a91033
MY
126%.config: $(obj)/conf
127 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
128 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
129 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
3aaefce1
JT
130
131PHONY += kvmconfig
63a91033
MY
132kvmconfig: kvm_guest.config
133 @:
3aaefce1 134
6c668505
LR
135PHONY += xenconfig
136xenconfig: xen.config
137 @:
138
0da1d4a0 139PHONY += tinyconfig
63a91033
MY
140tinyconfig:
141 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
0da1d4a0 142
022a4bf6
MY
143# CHECK: -o cache_dir=<path> working?
144PHONY += testconfig
145testconfig: $(obj)/conf
146 $(PYTHON3) -B -m pytest $(srctree)/$(src)/tests \
147 -o cache_dir=$(abspath $(obj)/tests/.cache) \
148 $(if $(findstring 1,$(KBUILD_VERBOSE)),--capture=no)
149clean-dirs += tests/.cache
150
1da177e4
LT
151# Help text used by make help
152help:
153 @echo ' config - Update current config utilising a line-oriented program'
fa75a727
GU
154 @echo ' nconfig - Update current config utilising a ncurses menu based'
155 @echo ' program'
1da177e4 156 @echo ' menuconfig - Update current config utilising a menu based program'
092373c2 157 @echo ' xconfig - Update current config utilising a Qt based front-end'
39c3f1ba 158 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
1da177e4 159 @echo ' oldconfig - Update current config utilising a provided .config as base'
03fa25da 160 @echo ' localmodconfig - Update current config disabling modules not loaded'
281c9dad 161 @echo ' localyesconfig - Update current config converting local mods to core'
0748cb3e 162 @echo ' defconfig - New config with default from ARCH supplied defconfig'
7cf3d73b 163 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
e11f0496 164 @echo ' allnoconfig - New config where all options are answered with no'
0748cb3e
SR
165 @echo ' allyesconfig - New config where all options are accepted with yes'
166 @echo ' allmodconfig - New config selecting modules when possible'
167 @echo ' alldefconfig - New config with all symbols set to default'
168 @echo ' randconfig - New config with random answer to all options'
861b4ea4 169 @echo ' listnewconfig - List new options'
cedd55d4
MH
170 @echo ' olddefconfig - Same as oldconfig but sets new symbols to their'
171 @echo ' default value without prompting'
9bcd776d 172 @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
6c668505 173 @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
0da1d4a0 174 @echo ' tinyconfig - Configure the tiniest possible kernel'
1da177e4 175
2982de69
SR
176# lxdialog stuff
177check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
178
e9e40e14 179# Use recursively expanded variables so we do not call gcc unless
2982de69 180# we really need to do so. (Do not call gcc as part of make mrproper)
9ba95682
AL
181HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
182 -DLOCALE
2982de69 183
1da177e4
LT
184# ===========================================================================
185# Shared Makefile for the various kconfig executables:
186# conf: Used for defconfig, oldconfig and related targets
692d97c3 187# nconf: Used for the nconfig target.
188# Utilizes ncurses
6f26e5e4 189# mconf: Used for the menuconfig target
1da177e4
LT
190# Utilizes the lxdialog package
191# qconf: Used for the xconfig target
092373c2 192# Based on Qt which needs to be installed to compile it
1da177e4 193# gconf: Used for the gconfig target
39c3f1ba 194# Based on GTK+ which needs to be installed to compile it
1da177e4
LT
195# object files used by all kconfig flavours
196
2982de69
SR
197lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
198lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
199
1da177e4 200conf-objs := conf.o zconf.tab.o
692d97c3 201mconf-objs := mconf.o zconf.tab.o $(lxdialog)
202nconf-objs := nconf.o zconf.tab.o nconf.gui.o
3b9fa093 203kxgettext-objs := kxgettext.o zconf.tab.o
f1943049 204qconf-cxxobjs := qconf.o
5a6f8d2b
AL
205qconf-objs := zconf.tab.o
206gconf-objs := gconf.o zconf.tab.o
1da177e4 207
022af62d 208hostprogs-y := conf nconf mconf kxgettext qconf gconf
1da177e4 209
b23d1a24 210targets += zconf.lex.c
5a6f8d2b 211clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
9a8dfb39 212clean-files += gconf.glade.h
1020026f 213clean-files += config.pot linux.pot
1da177e4 214
6e588f6d
SR
215# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
216PHONY += $(obj)/dochecklxdialog
ff85a1a8 217$(addprefix $(obj)/, mconf.o $(lxdialog)): $(obj)/dochecklxdialog
6e588f6d 218$(obj)/dochecklxdialog:
7080e47b 219 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
6e588f6d
SR
220
221always := dochecklxdialog
222
aa1e5ef5
SR
223# Add environment specific flags
224HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
d0fd0428 225HOST_EXTRACXXFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCXX) $(HOSTCXXFLAGS))
70a6a0cb 226
1da177e4 227# generated files seem to need this to find local include files
2f76b358 228HOSTCFLAGS_zconf.lex.o := -I$(src)
1da177e4
LT
229HOSTCFLAGS_zconf.tab.o := -I$(src)
230
5a6f8d2b
AL
231HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
232HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
1da177e4 233
5a6f8d2b 234HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
37193147 235HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
1ea3ad4e 236 -Wno-missing-prototypes
1da177e4 237
7080e47b
AL
238HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
239
544e7e54 240HOSTLOADLIBES_nconf = $(shell \
7285996a
BN
241 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
242 || pkg-config --libs menu panel ncurses 2>/dev/null \
544e7e54 243 || echo "-lmenu -lpanel -lncurses" )
1da177e4
LT
244$(obj)/qconf.o: $(obj)/.tmp_qtcheck
245
022af62d 246ifeq ($(MAKECMDGOALS),xconfig)
b3a5225f 247$(obj)/.tmp_qtcheck: $(src)/Makefile
1da177e4
LT
248-include $(obj)/.tmp_qtcheck
249
092373c2 250# Qt needs some extra effort...
1da177e4 251$(obj)/.tmp_qtcheck:
d1b0dc90 252 @set -e; $(kecho) " CHECK qt"; \
588446a8
TM
253 if pkg-config --exists Qt5Core; then \
254 cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
255 libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
256 moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
257 elif pkg-config --exists QtCore; then \
258 cflags=`pkg-config --cflags QtCore QtGui`; \
259 libs=`pkg-config --libs QtCore QtGui`; \
260 moc=`pkg-config --variable=moc_location QtCore`; \
ab919c06 261 else \
d1b0dc90 262 echo >&2 "*"; \
588446a8
TM
263 echo >&2 "* Could not find Qt via pkg-config."; \
264 echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
d1b0dc90
TM
265 echo >&2 "*"; \
266 exit 1; \
b3a5225f
RZ
267 fi; \
268 echo "KC_QT_CFLAGS=$$cflags" > $@; \
269 echo "KC_QT_LIBS=$$libs" >> $@; \
270 echo "KC_QT_MOC=$$moc" >> $@
1da177e4
LT
271endif
272
273$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
274
022af62d 275ifeq ($(MAKECMDGOALS),gconfig)
1da177e4
LT
276-include $(obj)/.tmp_gtkcheck
277
39c3f1ba 278# GTK+ needs some extra effort, too...
1da177e4 279$(obj)/.tmp_gtkcheck:
37193147
AB
280 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
281 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
1da177e4
LT
282 touch $@; \
283 else \
5b580fa6
MM
284 echo >&2 "*"; \
285 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
286 echo >&2 "*"; \
1da177e4
LT
287 false; \
288 fi \
289 else \
5b580fa6
MM
290 echo >&2 "*"; \
291 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
292 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
293 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
294 echo >&2 "*"; \
1da177e4
LT
295 false; \
296 fi
297endif
298
bb3290d9 299$(obj)/zconf.tab.o: $(obj)/zconf.lex.c
1da177e4 300
5a6f8d2b 301$(obj)/qconf.o: $(obj)/qconf.moc
1da177e4 302
ebca026a
YS
303quiet_cmd_moc = MOC $@
304 cmd_moc = $(KC_QT_MOC) -i $< -o $@
305
306$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
307 $(call cmd,moc)
1da177e4 308
39c3f1ba 309# Extract gconf menu items for i18n support
46d26319 310$(obj)/gconf.glade.h: $(obj)/gconf.glade
2d80eb0f 311 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
a24a1b8e 312 $(obj)/gconf.glade